Index: trunk/sources/HeuristicLab.DataPreprocessing.Views/3.4/PreprocessingCheckedVariablesView.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.DataPreprocessing.Views/3.4/PreprocessingChartView.Designer.cs	(revision 14268)
+++ trunk/sources/HeuristicLab.DataPreprocessing.Views/3.4/PreprocessingCheckedVariablesView.Designer.cs	(revision 14381)
@@ -21,5 +21,5 @@
 
 namespace HeuristicLab.DataPreprocessing.Views {
-  partial class PreprocessingChartView {
+  partial class PreprocessingCheckedVariablesView {
     /// <summary> 
     /// Required designer variable.
@@ -45,42 +45,17 @@
     /// </summary>
     private void InitializeComponent() {
-      this.tableLayoutPanel = new System.Windows.Forms.TableLayoutPanel();
-      this.dataTableView = new HeuristicLab.DataPreprocessing.Views.PreprocessingDataTableView();
+      this.components = new System.ComponentModel.Container();
       this.splitContainer = new System.Windows.Forms.SplitContainer();
       this.checkedItemList = new HeuristicLab.DataPreprocessing.Views.PreprocessingCheckedItemListView();
-      this.tableLayoutPanel.SuspendLayout();
+      this.variablesListcontextMenuStrip = new System.Windows.Forms.ContextMenuStrip(this.components);
+      this.checkInputsTargetToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
+      this.checkOnlyInputsTargetToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
+      this.checkAllToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
+      this.uncheckAllToolStripMenuItem = new System.Windows.Forms.ToolStripMenuItem();
       ((System.ComponentModel.ISupportInitialize)(this.splitContainer)).BeginInit();
       this.splitContainer.Panel1.SuspendLayout();
-      this.splitContainer.Panel2.SuspendLayout();
       this.splitContainer.SuspendLayout();
+      this.variablesListcontextMenuStrip.SuspendLayout();
       this.SuspendLayout();
-      // 
-      // tableLayoutPanel
-      // 
-      this.tableLayoutPanel.ColumnCount = 1;
-      this.tableLayoutPanel.ColumnStyles.Add(new System.Windows.Forms.ColumnStyle());
-      this.tableLayoutPanel.Controls.Add(this.dataTableView, 0, 0);
-      this.tableLayoutPanel.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.tableLayoutPanel.Location = new System.Drawing.Point(0, 0);
-      this.tableLayoutPanel.Name = "tableLayoutPanel";
-      this.tableLayoutPanel.RowCount = 1;
-      this.tableLayoutPanel.RowStyles.Add(new System.Windows.Forms.RowStyle());
-      this.tableLayoutPanel.Size = new System.Drawing.Size(559, 403);
-      this.tableLayoutPanel.TabIndex = 6;
-      this.tableLayoutPanel.Layout += new System.Windows.Forms.LayoutEventHandler(this.tableLayoutPanel_Layout);
-      // 
-      // dataTableView
-      // 
-      this.dataTableView.AutoScroll = true;
-      this.dataTableView.Caption = "DataTable View";
-      this.dataTableView.Classification = null;
-      this.dataTableView.Content = null;
-      this.dataTableView.Dock = System.Windows.Forms.DockStyle.Fill;
-      this.dataTableView.IsDetailedChartViewEnabled = false;
-      this.dataTableView.Location = new System.Drawing.Point(3, 3);
-      this.dataTableView.Name = "dataTableView";
-      this.dataTableView.ReadOnly = false;
-      this.dataTableView.Size = new System.Drawing.Size(553, 397);
-      this.dataTableView.TabIndex = 0;
       // 
       // splitContainer
@@ -93,8 +68,4 @@
       // 
       this.splitContainer.Panel1.Controls.Add(this.checkedItemList);
-      // 
-      // splitContainer.Panel2
-      // 
-      this.splitContainer.Panel2.Controls.Add(this.tableLayoutPanel);
       this.splitContainer.Size = new System.Drawing.Size(654, 403);
       this.splitContainer.SplitterDistance = 91;
@@ -103,9 +74,10 @@
       // checkedItemList
       // 
-      this.checkedItemList.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom) 
-            | System.Windows.Forms.AnchorStyles.Left) 
+      this.checkedItemList.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+            | System.Windows.Forms.AnchorStyles.Left)
             | System.Windows.Forms.AnchorStyles.Right)));
       this.checkedItemList.Caption = "View";
       this.checkedItemList.Content = null;
+      this.checkedItemList.ContextMenuStrip = this.variablesListcontextMenuStrip;
       this.checkedItemList.Location = new System.Drawing.Point(4, 4);
       this.checkedItemList.Name = "checkedItemList";
@@ -114,16 +86,54 @@
       this.checkedItemList.TabIndex = 4;
       // 
-      // PreprocessingChartView
+      // variablesListcontextMenuStrip
+      // 
+      this.variablesListcontextMenuStrip.Items.AddRange(new System.Windows.Forms.ToolStripItem[] {
+            this.checkInputsTargetToolStripMenuItem,
+            this.checkOnlyInputsTargetToolStripMenuItem,
+            this.checkAllToolStripMenuItem,
+            this.uncheckAllToolStripMenuItem});
+      this.variablesListcontextMenuStrip.Name = "variablesListcontextMenuStrip";
+      this.variablesListcontextMenuStrip.Size = new System.Drawing.Size(211, 92);
+      this.variablesListcontextMenuStrip.Opening += new System.ComponentModel.CancelEventHandler(this.variablesListcontextMenuStrip_Opening);
+      // 
+      // checkInputsTargetToolStripMenuItem
+      // 
+      this.checkInputsTargetToolStripMenuItem.Name = "checkInputsTargetToolStripMenuItem";
+      this.checkInputsTargetToolStripMenuItem.Size = new System.Drawing.Size(210, 22);
+      this.checkInputsTargetToolStripMenuItem.Text = "Check Inputs+Target";
+      this.checkInputsTargetToolStripMenuItem.Click += new System.EventHandler(this.checkInputsTargetToolStripMenuItem_Click);
+      // 
+      // checkOnlyInputsTargetToolStripMenuItem
+      // 
+      this.checkOnlyInputsTargetToolStripMenuItem.Name = "checkOnlyInputsTargetToolStripMenuItem";
+      this.checkOnlyInputsTargetToolStripMenuItem.Size = new System.Drawing.Size(210, 22);
+      this.checkOnlyInputsTargetToolStripMenuItem.Text = "Check only Inputs+Target";
+      this.checkOnlyInputsTargetToolStripMenuItem.Click += new System.EventHandler(this.checkOnlyInputsTargetToolStripMenuItem_Click);
+      // 
+      // checkAllToolStripMenuItem
+      // 
+      this.checkAllToolStripMenuItem.Name = "checkAllToolStripMenuItem";
+      this.checkAllToolStripMenuItem.Size = new System.Drawing.Size(210, 22);
+      this.checkAllToolStripMenuItem.Text = "Check All";
+      this.checkAllToolStripMenuItem.Click += new System.EventHandler(this.checkAllToolStripMenuItem_Click);
+      // 
+      // uncheckAllToolStripMenuItem
+      // 
+      this.uncheckAllToolStripMenuItem.Name = "uncheckAllToolStripMenuItem";
+      this.uncheckAllToolStripMenuItem.Size = new System.Drawing.Size(210, 22);
+      this.uncheckAllToolStripMenuItem.Text = "Uncheck All";
+      this.uncheckAllToolStripMenuItem.Click += new System.EventHandler(this.uncheckAllToolStripMenuItem_Click);
+      // 
+      // PreprocessingCheckedVariablesView
       // 
       this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
       this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
       this.Controls.Add(this.splitContainer);
-      this.Name = "PreprocessingChartView";
+      this.Name = "PreprocessingCheckedVariablesView";
       this.Size = new System.Drawing.Size(654, 403);
-      this.tableLayoutPanel.ResumeLayout(false);
       this.splitContainer.Panel1.ResumeLayout(false);
-      this.splitContainer.Panel2.ResumeLayout(false);
       ((System.ComponentModel.ISupportInitialize)(this.splitContainer)).EndInit();
       this.splitContainer.ResumeLayout(false);
+      this.variablesListcontextMenuStrip.ResumeLayout(false);
       this.ResumeLayout(false);
 
@@ -132,8 +142,11 @@
     #endregion
 
-    private PreprocessingCheckedItemListView checkedItemList;
-    private DataPreprocessing.Views.PreprocessingDataTableView dataTableView;
-    private System.Windows.Forms.TableLayoutPanel tableLayoutPanel;
+    protected PreprocessingCheckedItemListView checkedItemList;
     protected System.Windows.Forms.SplitContainer splitContainer;
+    private System.Windows.Forms.ContextMenuStrip variablesListcontextMenuStrip;
+    private System.Windows.Forms.ToolStripMenuItem checkInputsTargetToolStripMenuItem;
+    private System.Windows.Forms.ToolStripMenuItem checkAllToolStripMenuItem;
+    private System.Windows.Forms.ToolStripMenuItem uncheckAllToolStripMenuItem;
+    private System.Windows.Forms.ToolStripMenuItem checkOnlyInputsTargetToolStripMenuItem;
   }
 }